-- INFORMIX Dynamic 4GL Demonstration
--
-- @(#)$Id: d4_repd4gl.4gl,v 1.12 1998/08/20 18:24:42 jleffler Exp $
--
-- $Product: INFORMIX Dynamic 4GL Demonstration Version 2.00.UC8 (1998-08-25) $

--# GLOBALS "d4_globals.4gl"
--#
--# DEFINE products ARRAY[100] OF RECORD
--#                 stock_num   LIKE Stock.Stock_Num,
--#                 description LIKE Stock.Description
--#                 END RECORD
--# DEFINE nprod    INTEGER
--# DEFINE cur_prod LIKE Stock.Stock_Num
--#
--# DEFINE colors ARRAY[8] OF CHAR(7)
--#
--# FUNCTION graphit()
--#
--#     IF nprod IS NULL OR nprod <= 0 THEN
--#         -- Initialization code
--#         LET colors[1] = "red"
--#         LET colors[2] = "blue"
--#         LET colors[3] = "green"
--#         LET colors[4] = "cyan"
--#         LET colors[5] = "yellow"
--#         LET colors[6] = "magenta"
--#         LET colors[7] = "white"
--#         LET colors[8] = "black"
--#         LET cur_prod  = 0
--#         LET nprod     = 0
--#         CALL drawinit()
--#     END IF
--#
--#     MENU "Graphical Reports"
--#
--#     BEFORE MENU
--#         IF cur_prod = 0 THEN
--#             HIDE OPTION "Report"
--#         END IF
--#
--#     COMMAND "Product"
--#             "Choose the product"
--#             HELP 2010
--#         IF select_product() THEN
--#             EXIT MENU
--#         END IF
--#         IF cur_prod != 0 THEN
--#             SHOW OPTION "Report"
--#         END IF
--#
--#     COMMAND "Report"
--#             "Sales Report by Manufacturer for Product"
--#         IF graphic_report(products[cur_prod].stock_num, products[cur_prod].description) THEN
--#             EXIT MENU
--#         END IF
--#
--#     COMMAND "Exit"
--#             "Exit Graphical Reports Menu"
--#         EXIT MENU
--#
--#     END MENU
--#
--# END FUNCTION {graphit}
--#
--# FUNCTION select_product()
--#
--#     DEFINE rownum INTEGER
--#
--#     IF nprod = 0 THEN
--#         DECLARE c_prodlist CURSOR FOR
--#             SELECT DISTINCT Stock_Num, Description
--#                 FROM Stock
--#                 ORDER BY Stock_Num
--#         FOREACH c_prodlist INTO products[nprod + 1].*
--#             LET nprod = nprod + 1
--#             IF nprod > 100 THEN -- 100: dimension of products array
--#                 EXIT FOREACH
--#             END IF
--#         END FOREACH
--#     END IF
--#
--#     IF nprod = 0 THEN
--#         ERROR "Failed to select any products"
--#         RETURN 1
--#     ELSE
--#         OPEN WINDOW w_prodlist AT 1, 1 WITH FORM "products"
--#         CALL SET_COUNT(nprod)
--#         MESSAGE "Choose the product"
--#         DISPLAY ARRAY products TO s_products.*
--#         BEFORE DISPLAY
--#             IF cur_prod > 0 THEN
--#                 LET rownum = 5
--#                 IF cur_prod < 5 THEN
--#                     LET rownum = cur_prod
--#                 END IF
--#                 CALL dialog.setcurrline(rownum, cur_prod)
--#             END IF
--#         END DISPLAY
--#         IF INT_FLAG THEN
--#             LET INT_FLAG = 0
--#             RETURN 1
--#         END IF
--#         LET cur_prod = ARR_CURR()
--#     END IF
--#
--#     RETURN 0
--#
--# END FUNCTION {select_product}
--#
--# -- Graphical Reporting
--# FUNCTION graphic_report(stknum, stkdesc)
--#
--#     DEFINE stknum   LIKE Stock.Stock_Num
--#     DEFINE stkdesc  LIKE Stock.Description
--#     DEFINE choice   CHAR(20)
--#     DEFINE msg      CHAR(80)
--#
--#     --  Let user decide on report format
--#     LET choice = "array"
--#     OPEN WINDOW w_dispopt AT 8, 7 WITH 16 ROWS, 60 COLUMNS
--#                     ATTRIBUTE(BORDER, FORM LINE 1)
--#     OPEN FORM f_dispopt FROM "dispopt"
--#     DISPLAY FORM f_dispopt
--#     DISPLAY "Total Sales of Product by Manufacturer" AT 1, 1
--#     LET msg = "Product: ", stkdesc CLIPPED
--#     DISPLAY msg AT 2, 1
--#     INPUT BY NAME choice WITHOUT DEFAULTS HELP 2012
--#     CLOSE FORM f_dispopt
--#     CLOSE WINDOW w_dispopt
--#
--#     IF INT_FLAG THEN
--#         LET INT_FLAG = 0
--#         RETURN 1
--#     END IF
--#
--#     SELECT M.manu_name, S.description, SUM(I.total_price) tsum
--#         FROM items I, stock S, manufact M
--#         WHERE I.stock_num = stknum
--#           AND I.stock_num = S.stock_num
--#           AND I.manu_code = S.manu_code
--#           AND I.manu_code = M.manu_code
--#         GROUP BY I.manu_code, S.description, M.manu_name
--#         ORDER BY tsum DESC
--#         INTO TEMP T1
--#
--#     IF sqlca.sqlerrd[3] = 0 THEN
--#         LET msg = "Nobody has ever ordered any ", stkdesc
--#         CALL fgl_winmessage("No data", msg, "info")
--#     ELSE
--#         CASE
--#         WHEN choice MATCHES "array"
--#             CALL disp_array()
--#         WHEN choice MATCHES "bar_chart"
--#             CALL bar(stkdesc)
--#         WHEN choice MATCHES "pie_chart"
--#             CALL pie(stkdesc)
--#         WHEN choice MATCHES "report"
--#             CALL plain_report()
--#         WHEN choice MATCHES "dde_excel"
--#             CALL dde_it()
--#         WHEN choice MATCHES "export"
--#             CALL export_it()
--#         END CASE
--#     END IF
--#
--#     DROP TABLE T1
--#     IF INT_FLAG THEN
--#         LET INT_FLAG = 0
--#         RETURN 1
--#     END IF
--#     RETURN 0
--#
--# END FUNCTION {graphic_report}
--#
--# -- Plain REPORT
--# FUNCTION plain_report()
--#
--#     DEFINE res      RECORD
--#                     manu_name   LIKE manufact.manu_name,
--#                     descr       LIKE stock.description,
--#                     tsum2       LIKE items.total_price
--#                     END RECORD
--#
--#     DECLARE c_report1 CURSOR FOR
--#                 SELECT * FROM T1 ORDER BY tsum
--#
--#     START REPORT rf_plain
--#     FOREACH c_report1 INTO res.*
--#         OUTPUT TO REPORT rf_plain(res.*)
--#     END FOREACH
--#
--#     FINISH REPORT rf_plain
--#     FREE c_report1
--#
--# END FUNCTION {plain_report}
--#
--# REPORT rf_plain(res)
--#
--#     DEFINE res      RECORD
--#                     manu_name   LIKE manufact.manu_name,
--#                     descr       LIKE stock.description,
--#                     tsum2       LIKE items.total_price
--#                     END RECORD
--#
--#     FORMAT
--#
--#     PAGE HEADER
--#         PRINT
--#             COLUMN  1, "Manufacturer",
--#             COLUMN 15, "Item",
--#             COLUMN 35, "Total Sales"
--#
--#     ON EVERY ROW
--#         PRINT
--#             COLUMN  1, res.manu_name,
--#             COLUMN 15, res.descr,
--#             COLUMN 35, res.tsum2 USING "----,--&.&&"
--#
--#     ON LAST ROW
--#         PRINT
--#             COLUMN 31, "================"
--#         PRINT
--#             COLUMN 31, SUM(res.tsum2) USING "-,---,---,--&.&&"
--#
--# END REPORT {rf_plain}
--#
--# -- Display in a Display Array
--# FUNCTION disp_array()
--#
--#     DEFINE res      ARRAY[20] OF RECORD
--#                     manu_name   LIKE manufact.manu_name,
--#                     descr       LIKE stock.description,
--#                     tsum2       LIKE items.total_price
--#                     END RECORD
--#     DEFINE cnt      SMALLINT
--#
--#     OPEN WINDOW disp AT 6, 5 WITH FORM "disp_form"
--#                     ATTRIBUTE(BORDER, FORM LINE 1)
--#
--#     DECLARE c_disparr1 CURSOR FOR SELECT * FROM T1
--#
--#     LET cnt = 0
--#     FOREACH c_disparr1 INTO res[cnt + 1].*
--#         LET cnt = cnt + 1
--#     END FOREACH
--#
--#     FREE c_disparr1
--#
--#     CALL SET_COUNT(cnt)
--#     DISPLAY ARRAY res TO disparr.*
--#     CLOSE WINDOW disp
--#
--# END FUNCTION {disp_array}
--#
--# FUNCTION open_drawform()
--#
--#     OPEN WINDOW w_draw2 AT 4,5 WITH FORM "draw2"
--#                     ATTRIBUTE(BORDER, FORM LINE 1, MESSAGE LINE 1)
--#
--# END FUNCTION {open_drawform}
--#
--# FUNCTION close_drawform()
--#
--#     CALL DrawClear()
--#     CLOSE WINDOW w_draw2
--#
--# END FUNCTION {close_drawform}
--#
--# -- Print a pie graph.
--# -- A maximum of 8 sectors will be printed; if there are more than 8
--# -- manufacturers represented for a particular product (and there are
--# -- only 9 manufacturers in the standard stores7 demo), then group the
--# -- 8th and subsequent manufacturers into an "Others" category.  Note
--# -- that the bar chart prints a column for each manufacturer, but it
--# -- cannot have 2 segments of the same colour adjacent to each other.
--# FUNCTION pie(stkdesc)
--#
--#     DEFINE stkdesc      LIKE Stock.Description
--#     DEFINE msg          CHAR(80)
--#     DEFINE ttotal       MONEY(8)
--#     DEFINE degree       DECIMAL
--#     DEFINE itno         SMALLINT
--#     DEFINE arc1         SMALLINT
--#     DEFINE start        SMALLINT
--#     DEFINE cnt          SMALLINT
--#     DEFINE tnum         SMALLINT
--#     DEFINE start_key    SMALLINT
--#     DEFINE mname        CHAR(15)
--#     DEFINE descr        CHAR(15)
--#     DEFINE tsum2        MONEY(8)
--#     DEFINE itemList     ARRAY[8] OF RECORD
--#                         itemNum     INTEGER,
--#                         mname       LIKE Manufact.Manu_Name,
--#                         mtotal      MONEY(8)
--#                         END RECORD
--#     DEFINE ikey         CHAR(12)
--#     DEFINE pkey         CHAR(2)
--#     DEFINE fkey         CHAR(3)
--#     DEFINE i            INTEGER
--#     DEFINE c            CHAR(1)
--#     DEFINE key_f10      INTEGER
--#     DEFINE others       INTEGER
--#     DEFINE residue      MONEY(8)
--#
--#     CALL open_drawform()
--#
--#     SELECT SUM(tsum), COUNT(*) INTO ttotal, tnum FROM T1
--#
--#     LET others = FALSE
--#     IF tnum > 8 THEN
--#         LET tnum = 8
--#         LET others = TRUE
--#     END IF
--#
--#     LET degree = 360 / ttotal
--#     LET residue = ttotal
--#
--#     CALL DrawSelect("c01")
--#
--#     DECLARE c1 CURSOR FOR
--#         SELECT * FROM T1 ORDER BY tsum DESC
--#
--#     LET start_key = 890
--#     LET start = 0
--#     LET cnt = 1
--#     CALL drawAnchor("w")
--#
--#     LET msg = stkdesc CLIPPED, " - Total Sales By Manufacturer"
--#     LET itno = DrawText(950, 10, msg CLIPPED)
--#
--#     IF tnum = 1 THEN
--#         -- Not singularly elegant, but DrawArc doesn't seem to draw 360
--#         -- degree arcs correctly (or the logic doesn't calculate a single
--#         -- row as a 360 slice).
--#         FOREACH c1 INTO mname, descr, tsum2
--#             CALL drawfillcolor(colors[cnt])
--#             LET itemList[cnt].mname = mname
--#             LET itemList[cnt].mtotal = tsum2
--#             LET itemList[cnt].itemNum = drawcircle(900, 100, 500)
--#             LET itno = drawrectangle(start_key, 700, 25, 25)
--#             LET itno = DrawText(start_key + 12, 750, mname)
--#         END FOREACH
--#     ELSE
--#         FOREACH c1 INTO mname, descr, tsum2
--#             LET itemList[cnt].mtotal = tsum2
--#             IF cnt = tnum THEN
--#                 LET arc1 = 360 - start
--#                 IF others = TRUE THEN
--#                     LET itemList[cnt].mname = "Others"
--#                     LET itemList[cnt].mtotal = residue
--#                 ELSE
--#                     LET itemList[cnt].mname = mname
--#                 END IF
--#             ELSE
--#                 LET arc1 = tsum2 * degree
--#                 LET itemList[cnt].mname = mname
--#             END IF
--#             LET residue = residue - tsum2
--#             CALL drawfillcolor(colors[cnt])
--#             LET itemList[cnt].itemNum = drawarc(900, 100, 500, start, arc1)
--#             LET itno = drawrectangle(start_key, 700, 25, 25)
--#             LET itno = DrawText(start_key + 12, 750, itemList[cnt].mname)
--#             LET start = start + arc1
--#             LET start_key = start_key - 50
--#             IF cnt = tnum THEN
--#                 EXIT FOREACH
--#             END IF
--#             LET cnt = cnt + 1
--#         END FOREACH
--#     END IF
--#
--#     FREE c1
--#
--#     FOR i = 1 TO tnum
--#         LET pkey = i+10
--#         LET fkey = "F", pkey
--#         CALL DrawButtonLeft(itemList[i].itemNum, fkey)
--#     END FOR
--#
--#     MESSAGE "Click on a section to see the actual total sales figure"
--#
--#     LET key_f10 = FGL_KEYVAL("F10")
--#
--#     -- The multiple visible but blank function keys which appear on
--#     -- some systems are a nuisance.  They will not appear when the
--#     -- gui.empty.buttons.invisible = 1 attribute in fglprofile is
--#     -- acknowledged by the Tcl/Tk display code.
--#     INPUT c FROM FORMONLY.io
--#     BEFORE INPUT
--#         CALL dialog.keysetlabel("F11",  "")
--#         CALL dialog.keysetlabel("F12",  "")
--#         CALL dialog.keysetlabel("F13",  "")
--#         CALL dialog.keysetlabel("F14",  "")
--#         CALL dialog.keysetlabel("F15",  "")
--#         CALL dialog.keysetlabel("F16",  "")
--#         CALL dialog.keysetlabel("F17",  "")
--#         CALL dialog.keysetlabel("F18",  "")
--#     ON  KEY (F11, F12, F13, F14, F15, F16, F17, F18)
--#         LET i = FGL_LASTKEY() - key_f10
--#         LET msg = itemlist[i].mname CLIPPED, ": ", itemList[i].mtotal
--#         MESSAGE msg
--#     END INPUT
--#
--#     CALL close_drawform()
--#
--# END FUNCTION {pie}
--#
--# -- Print a bar graph
--# FUNCTION bar(stkdesc)
--#
--#     DEFINE stkdesc          LIKE Stock.Description
--#     DEFINE cnt              SMALLINT
--#     DEFINE itemnum          SMALLINT
--#     DEFINE start_x          SMALLINT
--#     DEFINE start_y          SMALLINT
--#     DEFINE max_x            SMALLINT
--#     DEFINE max_y            SMALLINT
--#     DEFINE segments         SMALLINT
--#     DEFINE startkey_x       SMALLINT
--#     DEFINE startkey_y       SMALLINT
--#     DEFINE key_interval     SMALLINT
--#     DEFINE key_width        SMALLINT
--#     DEFINE key_length       SMALLINT
--#     DEFINE key_y            SMALLINT
--#     DEFINE start_key_text   SMALLINT
--#     DEFINE start_bar        SMALLINT
--#     DEFINE scale            DECIMAL
--#     DEFINE num_bars         INTEGER
--#     DEFINE max_bar          INTEGER
--#     DEFINE bar_width        INTEGER
--#     DEFINE mname            CHAR(15)
--#     DEFINE descr            CHAR(15)
--#     DEFINE tsum2            MONEY(8)
--#     DEFINE c                INTEGER
--#     DEFINE msg              CHAR(80)
--#
--#     -- segments: divide the horizontal graph space allowed per
--#     -- manufacturer by 2, which allows equal width bar and spaces.
--#     LET segments = 2
--#
--#     LET start_x = 100
--#     LET start_y = 100
--#     LET max_x = 500
--#     LET max_y = 800
--#
--#     LET startkey_x = 700
--#     LET startkey_y = 800
--#     LET key_interval = 50
--#     LET key_width = 25
--#     LET key_length = 75
--#     LET start_key_text = startkey_x + key_length + 25
--#
--#     CALL open_drawform()
--#
--#     CALL DrawSelect("c01")
--#
--#     CALL DrawFillColor("black")
--#     LET itemnum = drawline(start_y, start_x, 0, max_x)
--#     LET itemnum = drawline(start_y, start_x, max_y, 0)
--#
--#     SELECT COUNT(*),  MAX(tsum)
--#         INTO num_bars, max_bar
--#         FROM T1
--#
--#     LET scale = max_y / max_bar
--#     LET bar_width = max_x / num_bars / segments
--#     LET start_bar = start_x + bar_width
--#
--#     --  Display title
--#     CALL drawAnchor("w")
--#     LET msg = stkdesc CLIPPED, " - Total Sales By Manufacturer"
--#     LET itemnum = DrawText(950, 10, msg CLIPPED)
--#
--#     --  Draw bars
--#     DECLARE q_curs2 CURSOR FOR
--#         SELECT * FROM T1 ORDER BY tsum DESC
--#
--#     LET cnt = 0
--#     LET key_y = startkey_y
--#     FOREACH q_curs2 INTO mname, descr, tsum2
--#         CALL DrawFillColor(colors[cnt+1])
--#         LET itemnum = DrawRectangle (start_y,
--#                          start_bar + bar_width * segments * cnt,
--#                          scale * tsum2, bar_width)
--#         LET itemnum = DrawRectangle (key_y, startkey_x, key_width,  key_length)
--#         LET itemnum = DrawText(key_y + 10, start_key_text, mname)
--#         LET cnt = cnt + 1
--#         LET key_y = key_y - key_interval
--#     END FOREACH
--#
--#     -- Do not do input from a widget unless tracking drawn items, as in
--#     -- the pie chart function.  Besides, this shows off the useful
--#     -- fgl_getkey() function built into standard D4GL.  There is an
--#     -- unofficial version of the code for I4GL at the IDN D4GL website,
--#     -- which is http://www.informix.com/idn.
--#
--#     MESSAGE "Click on OK to continue"
--#     LET c = fgl_getkey()
--#
--#     CALL close_drawform()
--#
--# END FUNCTION {bar}
